#!/usr/bin/perl

IRC::register("TXplay/xChat", "0.1.1", "", "");
IRC::add_command_handler("mp3", "play_mp3");
IRC::add_command_handler("wav", "play_wav");
IRC::add_command_handler("gg", "sound_grab");
IRC::add_message_handler("PRIVMSG", "checkprivmsg");

$mp3BASEdir = "/usr/local/mp3/";
$wavBASEdir = "/usr/local/wav/";
$tmpdir = "/tmp/";
$autosend=0;	#1 or anything
$autoget=0;     #1 or anything
$lastsound = '\0';

&DoStartup;
IRC::print "\0034loaded TXplay/xChat\003\n";

sub play_mp3 {
  #Generate the 2 Random colors for the BANNER
  my $colora = int(rand(14));
  my $colorb = int(rand(14));
  if ($colora == $colorb) {
    $colorb++;
  }

  #Get some info from xChat that we'll need
  my $name = IRC::get_info(1);
  my $channel = IRC::get_info(2);
  my $mp3 = shift(@_);

  #Set some vars for Finding the MP3.
  my $tmpdirout = $tmpdir."txplayout";
  my $filenameout = '\0';
  my $filename = '\0';
  my $foundit = 0;
  `find $mp3BASEdir \"(\" -iname \"$mp3\" \")\" -fprint $tmpdirout`;
mp3waitmore:
  if (open(FILE, $tmpdirout)) {
    while (<FILE>) {
      $filenameout = $_;
      if ($filenameout ne '\0') {
        $foundit = 1;
      }
    }
    close FILE;
  }
  else {
    goto mp3waitmore
  }
  `rm -f $tmpdirout`;

  if ($foundit==1) {
    my @tmplist = split('/',$filenameout);
    my $filename=$tmplist[5];
    open FILE, $filenameout;
    my ($filesize)=(stat(FILE))[7];
    close FILE;
    chop $filename;
    IRC::send_raw "PRIVMSG $channel :\001MP3 $filename\001\r\n";
    IRC::print "\0036<\003$name\0036>\003 \003$colora,$colorb!$name\003$colorb,$colora $filename \003$colora,$colorb<<$filesize>>\003\n";
    IRC::send_raw "PRIVMSG $channel :\003$colora,$colorb!$name\003$colorb,$colora $filename \003$colora,$colorb<<$filesize>>\003\n";
    `xmms $filenameout`;
  }
  return 1;
}

sub play_wav {
  my $colora = int(rand(14));
  my $colorb = int(rand(14));
  if ($colora == $colorb) {
    $colorb++;
  }
  my $name = IRC::get_info(1);
  my $channel = IRC::get_info(2);
  my $wav = shift(@_);

  my $tmpdirout = $tmpdir."txplayout";
  my $filenameout = '\0';
  my $filename = '\0';
  my $foundit = 0;
  `find $wavBASEdir \"(\" -iname \"$wav\" \")\" -fprint $tmpdirout`;
Wavwaitmore:
  if (open(FILE, $tmpdirout)) {
    while (<FILE>) {
      $filenameout = $_;
      if ($filenameout ne '\0') {
        $foundit = 1;
      }
    }
    close FILE;
  }
  else {
    goto Wavwaitmore
  }
  `rm -f $tmpdirout`;

  if ($foundit==1) {
    my @tmplist = split('/',$filenameout);
    my $filename=$tmplist[5];
    open FILE, $filenameout;
    my ($filesize)=(stat(FILE))[7];
    close FILE;

    IRC::send_raw "PRIVMSG $channel :\001SOUND $filename\001\r\n";
    IRC::print "\0036<\003$name\0036>\003 \003$colora,$colorb!$name\003$colorb,$colora $filename \003$colora,$colorb<<$filesize>>\003\n";
    IRC::send_raw "PRIVMSG $channel :\003$colora,$colorb!$name\003$colorb,$colora $filename \003$colora,$colorb<<$filesize>>\003\n";
    `xmms $filenameout`;
  }
  return 1;
}

sub sound_grab {
  if ($lastsound ne "") {
    IRC::send_raw "$lastsound\n";
  }
  else {
    IRC::print "\0034TXplay/xChat:\003 No sound to grab\n";
  }
  return 1;
}

sub checkprivmsg {
  $myname=IRC::get_info(1);
  $myname= "!" . $myname;
  my $line = shift(@_);
  $line =~ /:(.*)!(\S+) PRIVMSG (.*) :(.*)/i;
  $name=$1;
  $channel=$3;
  $text=$4;
  $name="$name";
  @wordlist=split(' ',$4);
  my $tmpdirout = $tmpdir."txplayout";
  my $filenameout = '\0';
  my $filename = '\0';
  my $foundit = 0;
  if ($myname eq $wordlist[0]) {
    `find $wavBASEdir \"(\" -iname \"$wordlist[1]\" \")\" -fprint $tmpdirout`;
privwaitmorestepa:
    if (open(FILE, $tmpdirout)) {
      while (<FILE>) {
        $filenameout = $_;
        if ($filenameout ne '\0') {
          $foundit = 1;
          goto privmsgwaitmorestepc
        }
      }
      close FILE;
    }
    else {
      goto privwaitmorestepa
    }
    `rm -f $tmpdirout`;
    `find $mp3BASEdir \"(\" -iname \"$wordlist[1]\" \")\" -fprint $tmpdirout`;
privwaitmorestepb:
    if (open(FILE, $tmpdirout)) {
      while (<FILE>) {
        $filenameout = $_;
        if ($filenameout ne '\0') {
          $foundit = 1;
        }
      }
      close FILE;
    }
    else {
      goto privwaitmorestepb
    }
    `rm -f $tmpdirout`;
privmsgstepc:
    if ($foundit==1) {
      chop $filenameout;
      IRC::print "\0034TXplay/xChat:\003 sending $filenameout to $name...\n";
      IRC::command "/dcc SEND $name $filenameout";
    }
    else {
      IRC::send_raw "PRIVMSG $name :Sorry, i don't have that file\n";
    }
  }
  if ($wordlist[0] eq "\001SOUND") {
    chop($wordlist[1]);
    $lastsound="PRIVMSG $name :!$name $wordlist[1]";
    `find $wavBASEdir \"(\" -iname \"$wordlist[1]\" \")\" -fprint $tmpdirout`;
privwaitmorea:
    if (open(FILE, $tmpdirout)) {
      while (<FILE>) {
        $filenameout = $_;
        if ($filenameout ne '\0') {
          $foundit = 1;
        }
      }
      close FILE;
    }
    else {
      goto privwaitmorea
    }
    `rm -f $tmpdirout`;
    if ($foundit==1) {
      `xmms $filenameout`;
    }
    else {
      if ($autoget==1) {
        $filename=$wordlist[1];
        chop($filename);
        IRC::send_raw "PRIVMSG $name :!$name $filename\n";
        IRC::print "\0034TXplay/xChat:\003 requesting $filename from $name...\n";
      }
    }
  }
  elsif($wordlist[0] eq "\001MP3") {
    chop($wordlist[1]);
    $lastsound="PRIVMSG $name :!$name $wordlist[1]";
    `find $mp3BASEdir \"(\" -iname \"$wordlist[1]\" \")\" -fprint $tmpdirout`;
privwaitmoreb:
    if (open(FILE, $tmpdirout)) {
      while (<FILE>) {
        $filenameout = $_;
        if ($filenameout ne '\0') {
          $foundit = 1;
        }
      }
      close FILE;
    }
    else {
      goto privwaitmoreb
    }
    `rm -f $tmpdirout`;
    if ($foundit==1) {
      `xmms $filenameout`;
    }
    else {
      if ($autoget==1) {
        $filename=$wordlist[1];
        chop($filename);
        IRC::send_raw "PRIVMSG $name :!$name $filename\n";
        IRC::print "\0034TXplay/xChat:\003 requesting $filename from $name...\n";
      }
    }
  }
  return 0;
}

#INTERNAL HANDLERS
sub DoStartup {
  my $user=$ENV{'USER'};
  my $path="/tmp/xmms_$user.0";
  if (!open(FILE, $path)) {
    IRC::command "/exec xmms";
  }
}
